; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_COMMAND_AUSWERTUNG:
	; ROM-COMMAND schon empfangen ?	
	LDS temp,(adr_OW_FUNCTION_COMMAND)
	tst temp
	brne FUNCTION_COMMAND_AUSWERTUNG_RUN
; ------------------------------------------------------------------------------
	; CLEAR							

	; ROM-COMMAND speichern			
	mov temp,OW_BYTE
	STS(adr_OW_FUNCTION_COMMAND),temp
; ------------------------------------------------------------------------------
FUNCTION_COMMAND_AUSWERTUNG_RUN:
	cpi temp,(OW_FUNCTION_CONVERT_T)				; CONWERT			
	brne PC+2
 	rjmp FUNCTION_CONVERT

	cpi temp,(OW_FUNCTION_MASTER_READ_SCRATCHPAD)	; READ_SCRATCHPAD	
	brne PC+2
 	rjmp FUNCTION_MASTER_READ_SCRATCHPAD

	cpi temp,(OW_FUNCTION_MASTER_WRITE_SCRATCHPAD)	; WRITE_SCRATCHPAD	
	brne PC+2
	rjmp FUNCTION_WRITE_SCRATCHPAD

	cpi temp,(OW_FUNCTION_MASTER_READ_DATA)			; READ-DATA-PRIVATE	
	brne PC+2
 	rjmp FUNCTION_MASTER_READ_DATA

	cpi temp,(OW_FUNCTION_MASTER_WRITE_DATA)		; WRITE-DATA-PRIVATE
	brne PC+2
	rjmp FUNCTION_MASTER_WRITE_DATA
	; unbekanntes ROM COMMAND ==> SPERREN
	rjmp STATUS_SPERREN_SETZEN		;  STATUS: gesperrt		
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_CONVERT:
	STS(adr_FREIGABE_MESSEN),EINS
rjmp STATUS_SPERREN_SETZEN					;  STATUS: gesperrt		
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_MASTER_READ_SCRATCHPAD:
	LDS temp,(adr_OW_BIT_NR)
	dec temp
	STS(adr_OW_BIT_NR),temp
	brne  FUNCTION_READ_SCRATCHPAD_w
; ------------------------------------------------------------------------------
	; neues BYTE laden							
	ldi temp,8
	STS(adr_OW_BIT_NR),temp

	LDS temp,(adr_OW_BYTE_ZAEHLER)				; BYTE-ZHLER		
	inc temp
	STS(adr_OW_BYTE_ZAEHLER),temp


	ldi ZL, LOW(adr_OW_SCRATCHPAD_BEREICH9-1)	; Z(SRAM)			
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_BEREICH9-1)
	add ZL,temp									; Z + ZHLER		
	adc ZH,NULL
	LD OW_BYTE,Z								; neues BYTE laden	
; ------------------------------------------------------------------------------
FUNCTION_READ_SCRATCHPAD_w:
	LSR	OW_BYTE									; logisch rechts	
	rjmp STATUS_TX_SLOT_SETZEN_C				; inp: C			
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
SCRATCHPAD_CRC8:
 	ldi ZL,low (adr_OW_SCRATCHPAD_BEREICH9+0) 	; Z-Zeiger 					
    ldi ZH,high(adr_OW_SCRATCHPAD_BEREICH9+0) 
    ldi     r19, 8                          ;8 Bytes berechnen			
    ldi     r20, 0x18                       ;Konstante fr Berechnung
    clr     r17                            	;CRC-Startwert = 0 setzen
SCRATCHPAD_CRC8_100: 
	LD      r18, Z+                         ;Byte aus Puffer holen
    mov     r21, r18                        ;Byte zwischenspeichern
    ldi     r16, 8                          ;8 Verschiebungen
SCRATCHPAD_CRC8_200: 
	eor     r18, r17                      	;CRC berechnen
    ror     r18                             ;Ergebnis in Carry schieben
    mov     r18, r17                      	;letzten CRC-Wert holen
    brcc    SCRATCHPAD_CRC8_300             ;war Ergebnis = 0? ja -> weiter
    eor     r18, r20                        ;sonst CRC-Wert updaten
SCRATCHPAD_CRC8_300: 
	ror     r18                             ;neuen CRC-Wert positionieren
    mov     r17, r18          	            ;und speichern
    mov     r18, r21                        ;restliche Bits holen
    bst     r18, 0                          ;LSB sichern, nchste Bitposition
    ror     r18                             ;gesichertes Bit als MSB einsetzen
    bld     r18, 7                          ;(Ersatz fr RR-Befehl)
    mov     r21, r18                        ;und Wert zwischenspeichern
    dec     r16                             ;alle Verschiebungen erledigt?
    brne    SCRATCHPAD_CRC8_200        		;nein -> Schleife		
    dec     r19                             ;alle Bytes bearbeitet?	
    brne    SCRATCHPAD_CRC8_100    		 	;nein -> Schleife		
;-------------------------------------------------------------------------------
	; Ergebnis in R17	
	STS(adr_OW_SCRATCHPAD_BEREICH9+8),R17
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_WRITE_SCRATCHPAD:
	; ZHLER+1			
	LDS temp,(adr_OW_BYTE_ZAEHLER)
	inc temp
	STS (adr_OW_BYTE_ZAEHLER),temp
	; BERLAUF ?		
	cpi temp,0
	breq FUNCTION_WRITE_SCRATCHPAD_ERROR
	; INITIALISIERUNG ?	
	cpi temp,1
	brne FUNCTION_WRITE_SCRATCHPAD_RUN
	ret
; ------------------------------------------------------------------------------
FUNCTION_WRITE_SCRATCHPAD_ERROR:
	rjmp STATUS_SPERREN_SETZEN					;  STATUS: gesperrt		
; ------------------------------------------------------------------------------
FUNCTION_WRITE_SCRATCHPAD_RUN:
	ldi ZL, LOW(adr_OW_SCRATCHPAD_BEREICH9-2)
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_BEREICH9-2)
	add ZL,temp
	adc ZH,NULL
	ST Z,OW_BYTE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_MASTER_READ_DATA:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_MASTER_WRITE_DATA:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

