; ##############################################################################
; ##############################################################################
; ##############################################################################
ROM_COMMAND_AUSWERTUNG:
	; ROM-COMMAND schon empfangen ?	
	LDS temp,(adr_OW_ROM_COMMAND)
	tst temp
	brne ROM_COMMAND_AUSWERTUNG_RUN
; ------------------------------------------------------------------------------
	STS(adr_OW_BIT_NR),EINS	; !!
	; ROM-COMMAND speichern			
	mov temp,OW_BYTE
	STS(adr_OW_ROM_COMMAND),temp
; ------------------------------------------------------------------------------
ROM_COMMAND_AUSWERTUNG_RUN:
	; AUSWERTUNG					
	cpi temp,(OW_COMMAND_READ_ROM)	; READ	
	brne PC+2
 	rjmp ROM_READ
	cpi temp,(OW_COMMAND_MATCH_ROM)	; MATCH	
	brne PC+2
 	rjmp ROM_MATCH
	cpi temp,(OW_COMMAND_SEARCH_ROM); SEARCH
	brne PC+2
 	rjmp ROM_SEARCH
	cpi temp,(OW_COMMAND_SKIP_ROM)	; SKIP	
	brne PC+2
 	rjmp ROM_SKIP
	; unbekanntes ROM COMMAND ==> SPERREN
	rjmp STATUS_SPERREN_SETZEN		;  STATUS: gesperrt		
; ##############################################################################
; ##############################################################################
; ##############################################################################
ROM_SKIP:
	STS(adr_OW_ROM_COMMAND_GESPERRT),EINS
	STS(adr_OW_FUNCTION_COMMAND_GESPERRT),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ROM_READ:
	LDS temp,(adr_OW_BIT_NR)
	dec temp
	STS(adr_OW_BIT_NR),temp
	brne ROM_READ_w
; ------------------------------------------------------------------------------
	; neues BYTE laden							
	ldi temp,8
	STS(adr_OW_BIT_NR),temp							; OW_BIT_NR=8		

	LDS temp,(adr_OW_BYTE_ZAEHLER)					; BYTE-ZHLER		
	inc temp
	STS(adr_OW_BYTE_ZAEHLER),temp

	ldi ZL, LOW(adr_OW_ROM_ID_BEREICH8-1)
	ldi ZH,HIGH(adr_OW_ROM_ID_BEREICH8-1)
	add ZL,temp										; Z + ZHLER		
	adc ZH,NULL
	LD OW_BYTE,Z									; neues BYTE laden	
; ------------------------------------------------------------------------------
ROM_READ_w:
	LSR	OW_BYTE									; logisch rechts	
	rjmp STATUS_TX_SLOT_SETZEN_C				; inp: C			
; ##############################################################################
; ##############################################################################
; ##############################################################################
ROM_MATCH:
	; ZHLER+1			
	LDS temp,(adr_OW_ROM_MATCH_ZAEHLER)
	inc temp
	STS (adr_OW_ROM_MATCH_ZAEHLER),temp
	cpi temp,2
	brsh ROM_MATCH_RUN
	ret
; ------------------------------------------------------------------------------
ROM_MATCH_RUN:
	ldi ZL, LOW(adr_OW_ROM_ID_BEREICH8-2)
	ldi ZH,HIGH(adr_OW_ROM_ID_BEREICH8-2)
	add ZL,temp				; ZHLER
	adc ZH,NULL
	LD temp,Z
	cp temp,OW_BYTE
	breq ROM_MATCH_w
	rjmp STATUS_SPERREN_SETZEN						;  STATUS: gesperrt		
ROM_MATCH_w:
	LDS temp,(adr_OW_ROM_MATCH_ZAEHLER)
	cpi temp,9
	breq ROM_MATCH_OK
	ret
; ------------------------------------------------------------------------------
ROM_MATCH_OK:
	STS(adr_OW_ROM_COMMAND_GESPERRT),EINS
	STS(adr_OW_FUNCTION_COMMAND_GESPERRT),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; ZHLER=1=A=TX ROMBIT															
; ZHLER=2=B=TX ROMBIT (Komplement)												
; ZHLER=3=  RX ANTWORT MASTER													
; 																				
; hier wird das RX_BYTE zweckentfremdet !										
; 																				
ROM_SEARCH:
	mov OW_BIT_NR,EINS		; "1",damit jedes OW-BIT ausgelesen werden kann !
; ------------------------------------------------------------------------------
	; SEARCH ZHLER+1		
	LDS temp,(adr_OW_ROM_SEARCH_ZAEHLER_AB)		; ZHLER-AB		
	inc temp
	STS (adr_OW_ROM_SEARCH_ZAEHLER_AB),temp		; ZHLER-AB		
	cpi temp,1
	breq ROM_SEARCH_AUF_TX_A
	cpi temp,2
	breq ROM_SEARCH_AUF_TX_B
	cpi temp,3
	breq ROM_SEARCH_AUF_RX
	rjmp ROM_SEARCH_AUF_TX_A_INITIALISIERUNG
; ------------------------------------------------------------------------------
ROM_SEARCH_AUF_TX_A_INITIALISIERUNG:
	; INITIALISIERUNG	
	STS (adr_OW_ROM_SEARCH_ZAEHLER_AB),EINS
	STS(adr_OW_ROM_SEARCH_BIT_ZAEHLER),EINS		; BIT-ZHLER	
	STS(adr_OW_ROM_SEARCH_ID_BYTE_NR),VOLL		; ID-BYTE-NR	
	rjmp ROM_SEARCH_AUF_TX_A_RUN
; ------------------------------------------------------------------------------
ROM_SEARCH_AUF_TX_A:
	; AUSWERTUNG A und gesendetes BIT vom MASTER (0b11000000)
	LSL OW_BYTE									; ist BIT6=BIT7 ?	
	brvc ROM_SEARCH_AUF_TX_A_RUN
 	; SLAVE nicht mehr antworten				
	rjmp STATUS_SPERREN_SETZEN					; SPERREN	
; ------------------------------------------------------------------------------
ROM_SEARCH_AUF_TX_A_RUN:
	; BIT-ZHLER-1		
	LDS temp,(adr_OW_ROM_SEARCH_BIT_ZAEHLER)	; BIT-ZHLER	
	dec temp
	STS(adr_OW_ROM_SEARCH_BIT_ZAEHLER),temp		; BIT-ZHLER	
	brne ROM_SEARCH_AUF_TX_A_RUN_w1
	ldi temp,8
	STS(adr_OW_ROM_SEARCH_BIT_ZAEHLER),temp		; BIT-ZHLER	
	; BYTE_NR-1			
	LDS temp,(adr_OW_ROM_SEARCH_ID_BYTE_NR)		; ID-BYTE-NR	
	inc temp
	STS(adr_OW_ROM_SEARCH_ID_BYTE_NR),temp		; ID-BYTE-NR	
	; BIT_STARTADRESSE	
	ldi ZL, LOW(adr_OW_ROM_ID_BEREICH8+0)
	ldi ZH,HIGH(adr_OW_ROM_ID_BEREICH8+0)
	add ZL,temp									; BYTE_NR		
	adc ZH,NULL
	LD temp,Z									; SEARCH_BYTE	
	STS(adr_OW_ROM_SEARCH_BYTE),temp			; SEARCH_BYTE	
ROM_SEARCH_AUF_TX_A_RUN_w1:
	LDS temp,(adr_OW_ROM_SEARCH_BYTE)			; SEARCH_BYTE	
	LSR	temp									; logisch rechts
	STS(adr_OW_ROM_SEARCH_BYTE),temp			; SEARCH_BYTE	
	; TX (A)			
	rcall STATUS_TX_SLOT_SETZEN_C				; inp: C (C bleibt erhalten)			
	ROR OW_BYTE									; 1xrechts ber CARRY (A) reinschieben	
	ret
; ------------------------------------------------------------------------------
ROM_SEARCH_AUF_TX_B:
	mov temp, OW_BYTE							; B								
	LSL temp									; logisch links	(A) rollt raus !
	; CARRY invertieren	
	ror temp
	subi temp, 0x80
	; TX (B)			
 	rjmp STATUS_TX_SLOT_SETZEN_C				; inp: C		
; ------------------------------------------------------------------------------
ROM_SEARCH_AUF_RX:
	STS (adr_OW_ROM_SEARCH_ZAEHLER_AB),NULL		; ZHLER-AB		
	rjmp STATUS_RX_BEREIT_SETZEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
