; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT B+C+D CLEAR																
PORT_CLEAR:
	ldi temp, 0b00000000	
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REGISTER_CLEAR:
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
;-------------------------------------------------------------------------------
; SCHLEIFE																		
PROGRAMM_CHECK_FEHLER:
	CLI											; INTERRUPTS sperren	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)	; GELB aus	
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)	; ROT  an	
	rcall WAIT_1s
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)	; ROT  aus	
	rcall WAIT_100ms
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; LED auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)	; GRN	
	sbi (LED_GELB_DDR) ,(LED_GELB_PIN_NR)	; GELB	
	sbi (LED_ROT_DDR)  ,(LED_ROT_PIN_NR)	; ROT	

	sbi (LED_0_DDR),(LED_0_PIN_NR)			; 0
	sbi (LED_1_DDR),(LED_1_PIN_NR)			; 1
	sbi (LED_2_DDR),(LED_2_PIN_NR)			; 2
	sbi (LED_3_DDR),(LED_3_PIN_NR)			; 3
	sbi (LED_4_DDR),(LED_4_PIN_NR)			; 4
	sbi (LED_5_DDR),(LED_5_PIN_NR)			; 5
	sbi (LED_6_DDR),(LED_6_PIN_NR)			; 6
	sbi (LED_7_DDR),(LED_7_PIN_NR)			; 7
	sbi (LED_8_DDR),(LED_8_PIN_NR)			; 8
	sbi (LED_9_DDR),(LED_9_PIN_NR)			; 9
	; LED  aus										
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)	; GELB aus	
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)	; ROT  aus	
	rcall LED_BALKEN_AUS					; BALKEN aus
	; LED Test										
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT an	
	rcall WAIT_10ms
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR) 	; GELB an	
	rcall WAIT_10ms
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN an	
	rcall WAIT_10ms
	cbi (LED_0_PORT),(LED_0_PIN_NR)			; 0 an	
	rcall WAIT_10ms
	cbi (LED_1_PORT),(LED_1_PIN_NR)			; 1 an	
	rcall WAIT_10ms
	cbi (LED_2_PORT),(LED_2_PIN_NR)			; 2 an	
	rcall WAIT_10ms
	cbi (LED_3_PORT),(LED_3_PIN_NR)			; 3 an	
	rcall WAIT_10ms
	cbi (LED_4_PORT),(LED_4_PIN_NR)			; 4 an	
	rcall WAIT_10ms
	cbi (LED_5_PORT),(LED_5_PIN_NR)			; 5 an	
	rcall WAIT_10ms
	cbi (LED_6_PORT),(LED_6_PIN_NR)			; 6 an	
	rcall WAIT_10ms
	cbi (LED_7_PORT),(LED_7_PIN_NR)			; 7 an	
	rcall WAIT_10ms
	cbi (LED_8_PORT),(LED_8_PIN_NR)			; 8 an	
	rcall WAIT_10ms
	cbi (LED_9_PORT),(LED_9_PIN_NR)			; 9 an	
	rcall WAIT_100ms
	rcall LED_BALKEN_AUS					; BALKEN aus
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)	; GELB aus	
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)	; ROT  aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
STOP_PROGRAMM:
	WDR
	rjmp STOP_PROGRAMM
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_BALKEN_AUS:
	sbi (LED_0_PORT),(LED_0_PIN_NR)			; 0 aus	
	sbi (LED_1_PORT),(LED_1_PIN_NR)			; 1 aus	
	sbi (LED_2_PORT),(LED_2_PIN_NR)			; 2 aus	
	sbi (LED_3_PORT),(LED_3_PIN_NR)			; 3 aus	
	sbi (LED_4_PORT),(LED_4_PIN_NR)			; 4 aus	
	sbi (LED_5_PORT),(LED_5_PIN_NR)			; 5 aus	
	sbi (LED_6_PORT),(LED_6_PIN_NR)			; 6 aus	
	sbi (LED_7_PORT),(LED_7_PIN_NR)			; 7 aus	
	sbi (LED_8_PORT),(LED_8_PIN_NR)			; 8 aus	
	sbi (LED_9_PORT),(LED_9_PIN_NR)			; 9 aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
